﻿"use strict";
//https://www.google.fr/search?q=mdn+getColumnHandler&sxsrf=APq-WBtRjCIQs7ThZ294r_fqv6dOJk2otw%3A1645567008891&source=hp&ei=IFwVYuvjM_-Qxc8PvtGpiAk&iflsig=AHkkrS4AAAAAYhVqMFpMHQ77QFffIJs8MK1sQYhQzpWw&ved=0ahUKEwjr85DoppT2AhV_SPEDHb5oCpEQ4dUDCAY&uact=5&oq=mdn+getColumnHandler&gs_lcp=Cgdnd3Mtd2l6EAMyBAgjECcyBAgjECcyBggjECcQEzIFCAAQgAQyBQgAEIAEMgUIABCABDIFCAAQgAQyBQgAEIAEMgUIABCABDIFCAAQgAQ6CwgAEIAEELEDEIMBOhEILhCABBCxAxCDARDHARDRAzoECAAQAzoRCC4QgAQQsQMQgwEQxwEQrwE6CAgAEIAEELEDOgsILhCABBDHARCvAToICC4QgAQQ1AJQAFjpCGCWCmgAcAB4AIABnQGIAfYDkgEDMS4zmAEAoAEBoAEC&sclient=gws-wiz
var { Services } = ChromeUtils.import("resource://gre/modules/Services.jsm");

var { ExtensionCommon } = ChromeUtils.import("resource://gre/modules/ExtensionCommon.jsm");

var columns = class extends ExtensionCommon.ExtensionAPI {
getAPI(context) {
    // Return the experimental API
    return {
columns :{
copyObj(obj){
let l = []
for (let e in obj)l.push(e)
l.sort()
context.apiObj.speech.copyString(l.join("\r\n"))
},
async init (windowId){
},// init 
getMail3Pane(){
return Services.wm.getMostRecentWindow("mail:3pane");
},// end getMail3Pane
async show(type){
let focusedElement = Services.focus.focusedElement
if (focusedElement && focusedElement.id != "chichi_list")
{this.addColumns(focusedElement.ownerDocument);
this.lastFocusedElement = focusedElement;}
},// show
addColumns(document){
let window = document.defaultView
let list = window.document.getElementById("chichi_list");
let group_cols_activated = window.document.createElement("optgroup");
group_cols_activated.setAttribute("label", context.apiObj.i18n.getMessage("displayedColumns"));
group_cols_activated.setAttribute("aria-labeled","oui");
let group_cols_desactivated = window.document.createElement("optgroup");
group_cols_desactivated.setAttribute("label", context.apiObj.i18n.getMessage("hiddenColumns"));
list.appendChild(group_cols_activated)
list.appendChild(group_cols_desactivated)
for (let apiName of "runtime speech tabs".split (" ")) 
{context.apiCan.findAPIPath(apiName)}
let col = window.GetThreadTree().columns.getFirstColumn()
while(col){
let colName  = col.element.getAttribute ("display") || col.element.getAttribute ("label")
let option = window.document.createElement("option")
option.label = colName;
option.value = col.element.id;
option.setAttribute("colIndex", col.index);
((col.element.hidden) ? group_cols_desactivated : group_cols_activated).appendChild(option)
col = col.getNext();
}
list.hidden = false;
list.selectedIndex = 0;
list.focus();
context.cancelEventBlur = true;
list.addEventListener("blur", context.apiObj.columns.OnBlur);
list.addEventListener("keydown", context.apiObj.columns.OnKeyDown)
},// addColumn
OnBlur(){
if (!context.cancelEventBlur)
{return context.cancelEventBlur = true;}
this.removeEventListener("keydown", context.apiObj.columns.OnKeyDown)
this.removeEventListener("blur", context.apiObj.columns.OnBlur)
context.apiObj.userFolder.clearList(this.ownerDocument)
},// onblur 
OnKeyDown(event){
let which = event.which ;
if ((event.ctrlKey && !event.altKey && !event.shiftKey))
{return context.apiObj.columns.move(event);}
else if (which == event.DOM_VK_SPACE && event.target.selectedOptions[0].value != "subjectCol")
{context.apiObj.columns.toggleState(event)}
else if (which == event.DOM_VK_ESCAPE || which == event.DOM_VK_TAB)
{event.preventDefault();
context.apiObj.columns.lastFocusedElement.focus()}
},// onkeyDown 
toggleState(event){
let col = context.apiObj.columns.getMail3Pane().GetThreadTree().columns.getFirstColumn()
let cols = [];
let target = event.target;
let colIsActivated = target.selectedIndex < target.firstChild.childElementCount;
let curCol = target[target.selectedIndex];
let newCol = curCol.cloneNode(true)
let colIndex = parseInt(curCol.getAttribute("colIndex"));
while(col){
if (col.index == colIndex){
cols.push(colIndex)
break}
else if (!col.element.hidden)
{cols.push(parseInt(col.index))}
col = col.getNext();
}


// the column automatically changes group
let newIndex;
if (colIsActivated)
{ // a column is removed of first optGroup
newIndex =(!target) ? 1 : target.selectedIndex - 1
target.firstChild.removeChild(curCol)
target.lastChild.appendChild(newCol)
}
else
{
// a column is addedin first optGroup 
newIndex = cols.length - 1
target.firstChild.insertBefore(newCol, target.firstChild.children[newIndex])
target.lastChild.removeChild(curCol);
}//if 
target.selectedIndex = newIndex;
let realCol = context.apiObj.columns.getMail3Pane().document.getElementById(curCol.value)
realCol.hidden = !realCol.hidden;
context.cancelEventBlur = false;
target.blur();
target.focus();


},//toggleState
move(event){
let window = context.apiObj.columns.getMail3Pane()
event.preventDefault()
let target = event.target;
let which = event.which, curIndex = target.selectedIndex, newIndex
let childs = target.firstChild.children, maxIndex = target.firstChild.childElementCount
if (`${event.DOM_VK_UP} ${event.DOM_VK_LEFT}`.includes(which))
{newIndex = (which == event.DOM_VK_LEFT || curIndex == 0) ? 0 : (curIndex - 1)}
else if (`${event.DOM_VK_DOWN} ${event.DOM_VK_RIGHT}`.includes(which))
{newIndex = (which == event.DOM_VK_RIGHT || curIndex == (maxIndex-1)) ? (maxIndex - 1) : (curIndex + 1)}
else
{return;}
if (curIndex == newIndex || curIndex >= maxIndex)
{return;}
let curCol = target[curIndex]
let newCol = curCol.cloneNode(true);
let colBefore = window.document.getElementById(target.firstChild.children[newIndex].value)
let colMove = window.document.getElementById(curCol.value)

let c = context.apiObj.speech.copyString 


if (curIndex > newIndex)
{target.firstChild.insertBefore(newCol, target.firstChild.children[newIndex])
target.firstChild.removeChild(curCol)}
else
{target.firstChild.removeChild(curCol)
target.firstChild.insertBefore(newCol, target.firstChild.children[newIndex])
}
window.GetThreadTree()._reorderColumn(colMove, colBefore, curIndex > newIndex  )
context.cancelEventBlur = false;
target.blur();
target.selectedIndex = newIndex;
target.focus()
}// end OnKeyDown
} // columns
} // return object holding experiment APIs
  } // getAPI function
} // columns class
