﻿"use strict";

var { ExtensionCommon } = ChromeUtils.import("resource://gre/modules/ExtensionCommon.jsm");
var quickFilterBar = class extends ExtensionCommon.ExtensionAPI {
getAPI(context) {
    // Return the experimental API
    return {
quickFilterBar :{
init (windowId){
context.window = context.extension.windowManager.get(windowId, context).window;
if (!context.window) return 
context.apiCan.findAPIPath ("i18n")
this.create_tag_listBox (context.window)
this.shortenLabel (context.window)
this.create_filter_listBox (context.window)
this.addMutationObserver (context.window)
},
create_tag_listBox (window){
let target = window.document.getElementById ("quick-filter-bar-expando")
let select = window.document.createElement ("select")
let box =window.document.createElement ("box")
box.setAttribute ("i", "chichi_tag_box")
select.id ="chichi_tag_list"
let label = window.document.createElement ("label")
label.innerText =context.apiObj.i18n.getMessage ("tags")
label.setAttribute ("for", "chichi_tag_list")
label.id ="chichi_tag_label"
select.setAttribute ("accesskey", label.innerText[0])
box.appendChild (label)
box.appendChild (select)
target.appendChild (box)

select.addEventListener ("focus", this.OnFocus_tag_list )
select.addEventListener ("keypress", this.OnKeyPress_tag_list)

},
shortenLabel (window){
// shorten the label
let o =window.document.getElementById ("qfb-qs-textbox")
let s =o.getAttribute ("placeholder")
o.setAttribute ("placeholder", s.substr (0, s.indexOf ("<")))
//

},

addMutationObserver (window){
let speaker = window.document.getElementById ("chichi_speaker")

//
let target = context.window.document.getElementById ("qfb-results-label")
let config  = {"attributes": true}
let callBack = function (mutations){
for (let mutation of mutations){
if (!mutation.target.parentNode.parentNode.collapsed ){
if (mutation.target.style.visibility == "visible" && mutation.attributeName  == "value" ){context.apiObj.statusBar.speak ("".concat (mutation.target.value, ".")) }
else if (mutation.target.style.visibility =="hidden") { context.apiObj.statusBar.speak ("")}
}// if collapsed 
}}//for//function callback 
let ob = new window.MutationObserver (callBack)
ob.observe (target, config)
//
target = window.document.getElementById ("quick-filter-bar-tab-bar")
config = {attributes: true, childList : false }
callBack =  function (mutations){
let target = context.window.document.getElementById ("chichi_tag_box")
for (let mutation of mutations){
if (mutation.attributeName   == "collapsed" && target ){target.hidden = mutation.target.collapsed
}
}}
ob  =new window.MutationObserver (callBack)
ob.observe (target, config)
},// end addMutationObserver 
getCollapsibleButtons (){return context.window.document.getElementById ("quick-filter-bar-collapsible-buttons").getElementsByTagName ("toolbarbutton")},
getStickyButton  (){return context.window.document.getElementById ("qfb-sticky")},
async create_filter_listBox(window) {
let document  = window.document
let select=document.createElement ("select")
select.setAttribute ("id", "qfb_chichi_listBox")
let label = document.createElement ("label")
label.setAttribute ("for", "qfb_chichi_listBox")
label.innerText =context.apiObj.i18n.getMessage ("filter")
select.setAttribute ("accesskey", label.innerText[0])

let box = document.createElement ("box")
box.appendChild (label)
let o =document.getElementById ("quick-filter-bar-main-bar")
box.appendChild(select )
o.appendChild (box)
//we will match the buttons of the toolbar to the items of the list
// here we only deal with 2 toolbars out of 3, and each one separately
// the third toolbar will be managed by the onFocus function.
// we do this, either because of the display, or because the toolbars are independent
// first toolbar
let btn_sticky = this.getStickyButton ()
let option = document.createElement ("option")
option.value = btn_sticky.id 
option.setAttribute ("role", "checkbox")
option.label = btn_sticky.getAttribute ("tooltiptext")
select.appendChild (option)
//second  tool bar 
let buttons = this.getCollapsibleButtons ()
for (let button of buttons){
let option =document.createElement ("option")
option.label = button.label
option.setAttribute ("role","checkbox")
option.setAttribute ("value",button.id)
select.appendChild (option)
}//for 
select.addEventListener ("keypress", this.OnKeyPress)
select.addEventListener ("focus",this.OnFocus_filter_listBox)

}, // end createListBox
OnFocus_filter_listBox  (event){
let document =event.currentTarget.ownerDocument
//button sticky 
this.firstChild.setAttribute ("aria-checked", context.apiObj.quickFilterBar.getStickyButton ().hasAttribute ("checked"))
//ytag unread flagged contact ...
let counter  = 1
for (let button of context.apiObj.quickFilterBar.getCollapsibleButtons ()){
this.options[counter].setAttribute ("aria-checked", button.hasAttribute ("checked"))
counter++}

//show or hide the subject items body of the message ...
let buttons =document.getElementById ("quick-filter-bar-filter-text-bar").getElementsByTagName ("toolbarbutton")
if (document.getElementById ("qfb-qs-textbox").value) {
if (this.childElementCount == 6){
for (let button of buttons){
let option = document.createElement ("option")
option.setAttribute ("role", "checkbox")
option.setAttribute ("aria-checked", button.hasAttribute ("checked"))
option.label = button.label 
option.value = button.id
this.appendChild (option)
}}}
else {
while (this.childElementCount != 6){this.removeChild (select.lastChild)}
}

},//end focus
OnKeyPress (event){
let select = event.currentTarget 
let document = select.ownerDocument 
if (event.key ==" "){
let optionSelected  = select.selectedOptions[0]
let option = document.getElementById (optionSelected.value)
option.click ()
optionSelected.setAttribute ("aria-checked", option.hasAttribute ("checked"))
return event.preventDefault ()}



},// onfocus 
OnKeyPress_tag_list (event){
if (event.key  == " "){
let cur = this.selectedOptions[0]
let button = context.window.document.getElementById (cur.value)
button.click ()
cur.setAttribute ("aria-checked", button.hasAttribute ("checked"))
event.preventDefault ()
}
},
OnFocus_tag_list (event){
let document = context.window.document 
while (this.childElementCount) this.removeChild (this.firstChild)
let buttons =document.getElementById ("quick-filter-bar-tab-bar").getElementsByTagName ("toolbarbutton")
for (let button of buttons){
let option = document.createElement ("option")
option.value = button.id 
option.label = button.label 
option.setAttribute ("role", "checkbox")
option.setAttribute ("aria-checked", button.hasAttribute ("checked"))
this.appendChild (option)

}
}//on focus tag list 
      } // quickFilterBar
    } // return object holding experiment APIs
  } // getAPI function

 }; // quickFilterBar class