﻿"use strict";
var{MailUtils} = ChromeUtils.import("resource:///modules/MailUtils.jsm");
var{MailServices} = ChromeUtils.import("resource:///modules/MailServices.jsm");

var { ExtensionCommon } = ChromeUtils.import("resource://gre/modules/ExtensionCommon.jsm");

const nsMsgFolderFlagsTrash           = 0x00000100;
const nsMsgFolderFlagType_Junk            = 0x40000000;
const nsMsgFolderFlagType_Drafts          = 0x00000400;
const nsMsgFolderFlagType_SentMail        = 0x00000200;
const nsMsgFolderFlagType_Queue           = 0x00000800;
   const nsMsgFolderFlagType_Archive         = 0x00004000;

const specialFolderFlag = nsMsgFolderFlagsTrash | nsMsgFolderFlagType_Drafts | nsMsgFolderFlagType_SentMail | nsMsgFolderFlagType_Queue | nsMsgFolderFlagType_Archive | nsMsgFolderFlagType_Junk            ;


var userFolder = class extends ExtensionCommon.ExtensionAPI {
  onStartup() {}
  onShutdown(isAppShutdown) {
    // Clear caches that could prevent upgrades from working properly
    Services.obs.notifyObservers(null, "startupcache-invalidate", null);
  } // onShutdown function

getAPI(context) {
    context.callOnClose(this);

    // Return the experimental API
    return {
userFolder :{
copyObj(obj, sep=false){
let l = []
for (let attr in obj)l.push(attr)
l.sort()

l = ((sep)?"§":"") + l.join(`\r\n${(sep)?"§":""}`)
context.apiObj.speech.copyString(l)

},
getMail3Pane(){
return Services.wm.getMostRecentWindow("mail:3pane");
},// end getWindow 
async init(){
},//init 
OnBlur_unreadFolder (event){
let document = this.ownerDocument;
this.removeEventListener("keydown", context.apiObj.userFolder.OnKeyDown_unreadFolder)
this.removeEventListener("blur", context.apiObj.userFolder.OnBlur_unreadFolder)
context.apiObj.userFolder.clearList(document)
}, // OnBlur_unreadFolder
clearList(document){
document.getElementById("chichi_list_label").innerHTML = "";
let list = document.getElementById("chichi_list");
while (list.childElementCount)
{list.removeChild (list.firstChild)}
list.hidden = true;
},// clear list 
async show (type){
let activeElement = Services.focus.focusedElement;
if (activeElement && activeElement.id == "chichi_list")
{return;}
let document = activeElement.ownerDocument;
this.lastFocusedElement = activeElement
await this.clearList(activeElement.ownerDocument);
if (type == "unreadFolders")
{this.goToListUnreadFolders(document)}
else if (type == "accountInbox")
{this.addAccountInbox(document);}
else if (type=="accounts")
{this.goToAccountList()}
},// show
OnKeyDownAccountInbox(event){
let which = event.which;
let document = this.ownerDocument
if (which == event.DOM_VK_RETURN)
{document.defaultView.SelectFolder(event.target.selectedOptions[0].value);
context.apiObj.userFolder.goToFolderTree(document);
}
else if(which == event.DOM_VK_ESCAPE || which == event.DOM_VK_TAB)
{event.preventDefault()
return context.apiObj.userFolder.lastFocusedElement.focus();}
},//onKeydownAccountInbox
OnBlurAccountInbox(){
this.removeEventListener("keydown", context.apiObj.userFolder.OnKeyDownAccountInbox);
this.removeEventListener("blur", context.apiObj.userFolder.OnBlurAccountInbox);
context.apiObj.userFolder.clearList(this.ownerDocument);
},//OnBlurAccountInbox
addAccountInbox(document){
let list = document.getElementById("chichi_list");
let accounts = MailServices.accounts.accounts
for (let iAccount=0; iAccount<accounts.length; iAccount++){
let rootFolder= accounts[iAccount].incomingServer.rootFolder;
let inbox = MailUtils.getInboxFolder(rootFolder.server)
if (!inbox)inbox =rootFolder;
let option = document.createElement("option");
option.label = rootFolder.prettyName;
option.value = inbox.URI;
list.appendChild(option)
}
document.getElementById("chichi_list_label").innerHTML = context.apiObj.i18n.getMessage("inbox");
list.hidden = false;
list.selectedIndex = 0
list.addEventListener("keydown", context.apiObj.userFolder.OnKeyDownAccountInbox);
list.addEventListener("blur", this.OnBlurAccountInbox)
list.focus()

},// end account inbox
async goToListUnreadFolders(document){
this.browseFolders (document)
let list = document.getElementById("chichi_list");
if (!list.childElementCount)
{return context.apiObj.speech.say(
context.apiObj.i18n.getMessage("noMoreUnreadFolder"));}
document.getElementById("chichi_list_label").innerHTML = context.apiObj.i18n.getMessage("unreadMessageCount", this.unreadMessageCount);
list.addEventListener("keydown", this.OnKeyDown_unreadFolder);
list.addEventListener("blur", this.OnBlur_unreadFolder);
list.hidden =false;
list.selectedIndex = 0;
list.focus()
},// end unreadFolder 
addUnreadFolderToList(list, document, accountName, folder, numUnread){
this.unreadMessageCount += numUnread;
let prettyName = folder.prettyName
context.apiObj.speech.copyString(prettyName)
let option = document.createElement("option")
option.label = `${prettyName}, ${numUnread}, ${accountName}`
option.setAttribute("uri", folder.URI);
let c =context.apiObj.speech.copyString
// we move the inbox to the top
this.positionAccountsInGroup.chichi_accounts_index++;
if (!(accountName in this.positionAccountsInGroup))
{this.positionAccountsInGroup[accountName] = this.positionAccountsInGroup.chichi_accounts_index;}
// end of movement
//yannick
if (this.positionAccountsInGroup[accountName] != "don't check anymore" &&folder == MailUtils.getInboxFolder(folder.server))
{list.insertBefore(option, list.children[this.positionAccountsInGroup[accountName]])
this.positionAccountsInGroup[accountName] = "don't check anymore"
}
else
{list.appendChild (option)}
}, // add item list 
async browseFolders(document, objStart, sortBy, accountId=false, accountName=false){
this.positionAccountsInGroup = {chichi_accounts_index:-1}
this.unreadMessageCount = 0
let list = document.getElementById("chichi_list");
let accounts = MailServices.accounts.accounts
for (let iAccount=0; iAccount<accounts.length; iAccount++){
let rootFolder = accounts[iAccount].incomingServer.rootFolder;
let accountName = rootFolder.prettyName;
let totalNumUnread = rootFolder.getNumUnread(true);
if (!totalNumUnread)
{continue;}
let subFolders = rootFolder.subFolders;
for (let iSubFolder=0; iSubFolder<subFolders.length; iSubFolder++){
let folder = subFolders[iSubFolder];
let prettyName = folder.prettyName;
let folderNumUnread = folder.getNumUnread(true)
if (!folderNumUnread)
{continue;}
let isSpecialFolder = folder.isSpecialFolder(specialFolderFlag, true)
let descendants = folder.descendants;
let descendantsNumUnread = folder.getNumUnread(true);
let parentOfDescendantsNumUnread = folder.getNumUnread(false);
if (parentOfDescendantsNumUnread)
{descendantsNumUnread -= parentOfDescendantsNumUnread; 
totalNumUnread -= parentOfDescendantsNumUnread;
if (isSpecialFolder || prettyName.endsWith("-"))
{continue;}
else
{this.addUnreadFolderToList(list, document, accountName, folder, parentOfDescendantsNumUnread)}}
if (!totalNumUnread) break;
if (!descendantsNumUnread)continue;
let iDescendantsLength = descendants.length, iDescendants = 0;
if (!totalNumUnread)break;
while(descendantsNumUnread && iDescendants<iDescendantsLength){
let folder = descendants[iDescendants];
let prettyName = folder.prettyName;
let numUnread = folder.getNumUnread(false);
descendantsNumUnread -= numUnread
isSpecialFolder = folder.isSpecialFolder(specialFolderFlag, true)
if (numUnread && !isSpecialFolder && !prettyName.endsWith("-"))
{this.addUnreadFolderToList(list, document, accountName, folder, numUnread);}
totalNumUnread -= numUnread;
if(!totalNumUnread)break;
iDescendants += 1;
}
}// end for 
}//end of all loops
}, //end func browseFolders 
goToFolderTree(document){
let folderTree = document.getElementById("folderTree");
folderTree.focus();
},//
async displayFolder (list){
let o ;

let uri =list[list.selectedIndex].getAttribute("uri")
// we retrieve the folder from the folders api
let realFolder = MailServices.folderLookup.getFolderForURL(uri)
let folder = context.extension.folderManager.convert(realFolder);
let win = list.ownerDocument.defaultView
list.ownerDocument.defaultView.SelectFolder(list[list.selectedIndex].getAttribute("uri"));
win.gFolderDisplay.navigate(7 )
win.SetFocusThreadPane()
},// displayFolder
OnKeyDown_unreadFolder(event){
let which = event.which;
if (which  == event.DOM_VK_SPACE)
{event.preventDefault();
return context.apiObj.userFolder.markAllMessagesRead(event.target);}
else if (which == event.DOM_VK_RETURN)
{event.preventDefault();
context.apiObj.userFolder.displayFolder(event.target)}
else if (which == event.DOM_VK_ESCAPE || which == event.DOM_VK_TAB)
{context.apiObj.userFolder.lastFocusedElement.focus()
event.preventDefault();
}
},// OnKeyDown_unreadFolder
async goToAccountList(){
//ici 
let window = this.getMail3Pane()
for (let account of await context.apiObj.accounts .list ()){
let firstFolder =""
for (let folder of account.folders){
if (folder.type =="inbox")
{firstFolder = folder;break ;}
}//for 
if (firstFolder == "") firstFolder =account.folders[0]
let option = window.document.createElement ("option")
option.label = account.name
option.value ="".concat (account.id,"\t", firstFolder.path)
context.list.appendChild (option)
}
context.list.addEventListener ("keypress", function (event){
if (event.key =="Enter"){
let info =context.list.value.split ("\t")
context.apiObj.mailTabs.update (0, {"displayedFolder" : {"accountId": info[0], "path": info[1]}})
context.apiObj.userFolder.goToFolderTree ()
}})
context.label.innerText="compte"
context.list.focus ()
},//accountsFolder 
async displayInList_sortBy(){
//ici
let sortTypes = "date received flagged id priority recipient correspondent size status subject unread tags junkStatus attachments author thread location account".split (" ")
let currentTab  = await context.apiObj.mailTabs.getCurrent ()
let sortedBy = currentTab.sortType 
let sortOrderBy = currentTab.sortOrder 
let index  =0
let window = this.getMail3Pane()
for (let sortOrder  of ["ascending", "descending"] ){
let checked = (sortOrder == sortOrderBy)
let option = window.document.createElement ("option")
option.value = sortOrder
option.label = context.apiObj.i18n.getMessage (sortOrder )
option.setAttribute ("role","checkbox")
option.setAttribute ("aria-checked", checked)
context.list.appendChild (option)
index++
}

for (let sortType of sortTypes ){
let option = window.document.createElement ("option")
let checked = (sortedBy == sortType) ? true :false
option.value = sortType
option.label = context.apiObj.i18n.getMessage (sortType)
option.setAttribute ("role","checkbox")
option.setAttribute ("aria-checked", checked)
if (checked ) context.list.sortType  = index 


context.list.appendChild (option)
index ++
}
context.list.name ="sortBy"
context.list.value = sortedBy 
context.list.focus ()
context.label.innerText =context.apiObj.i18n.getMessage ("sortBy")

},//sortby 
update_checkBox_sortBy (list, option, selectedIndex){
//ici 
let state = (option.getAttribute ("aria-checked") == "false")
if (!state) return 
option.setAttribute ("aria-checked", (state))
if (selectedIndex < 2) {list.options[((selectedIndex ==1) ?0:1)].setAttribute ("aria-checked", false)}
else
{list.options[list.sortType].setAttribute ("aria-checked", false)
list.sortType = selectedIndex }
},//update_checkBox_sortBy 
markAllMessagesRead (list){
// all messages are marked as read
let msgWindow = list.ownerDocument.defaultView.msgWindow
let option = list.selectedOptions[0];
MailUtils.getExistingFolder(option.getAttribute("uri")).markAllMessagesRead(msgWindow);
// update list 
if (list.childElementCount == 1) 
{context.apiObj.userFolder.clearList(list.ownerDocument);
return context.apiObj.userFolder.lastFocusedElement.focus();}
list.selectedIndex = ((option.nextSibling) ? option.nextSibling : option.previousSibling).index;
list.removeChild(option)
}//markAllMessagesRead
}//},
 // userFolder
} // return object holding experiment APIs
  } // getAPI function


} // userFolder class

