﻿"use strict";
var{MailServices} = ChromeUtils.import("resource:///modules/MailServices.jsm");

var { ExtensionCommon } = ChromeUtils.import("resource://gre/modules/ExtensionCommon.jsm");
var userMessage = class extends ExtensionCommon.ExtensionAPI {
getAPI(context) {
    context.callOnClose(this);
    // Return the experimental API
   return {
userMessage : {
show(type){
let now = Date.now();
let isRepeatedKey = false;
if (!this.lastTime) 
{this.lastTime = now;}
else
{isRepeatedKey = (now - this.lastTime) <= 750 ;
this.lastTime = now;}
type ="readMessage"
if (type == "readMessage")
{context.apiObj.userMessage.readMessageOrShowLinks(isRepeatedKey)}
}, // end show 
isRSSFeed(objWebSite){
return !objWebSite.parentNode.hidden
}, // isRSSFeed
getURLRSSFeed(objWebSite){
let url = objWebSite.getAttribute("aria-label")
return url.substr(url.indexOf(":")+2);
},//getURLRSSFeed
readMessageOrShowLinks(isRepeatedKey){
let document = Services.focus.focusedElement.ownerDocument;
let pane = document.getElementById("messagepane")
let objWebSite = document.getElementById("expandedcontent-baseBox")
if (isRepeatedKey){
if (this.isRSSFeed(objWebSite)) 
{this.openURL(this.getURLRSSFeed(objWebSite));}
else
{this.showLinks(document, pane.contentDocument.links)}
}
else
{let body = document.getElementById("messagepane").contentDocument.body;
let text = body.outerText;
context.apiObj.speech.say(text)
}
},//readMessageOrShowLinks
showLinks(document, links){
context.apiObj.userFolder.clearList(document)
let list = document.getElementById("chichi_list");
let hrefs = []
for (let link of links){
let href = link.href;
if (href.startsWith("#") || hrefs.indexOf(href) >= 0){ 
continue}
let option = document.createElement("option");
let img = link.getElementsByTagName("img")[0];
let altText = (img) ? img.alt : ""
option.label = link.outerText || link.title || altText || href
option.value = href;
list.append(option)
hrefs.push(href);
}
if (!hrefs.length) return context.apiObj.speech.say(context.apiObj.i18n.getMessage("noLink"))
list.hidden = false;
list.selectedIndex = 0;
list.focus();
list.addEventListener("keydown", this.OnKeyDown);
list.addEventListener("blur", this.OnBlur);
},// readMessage
copyLinkToClipboard(event){
context.apiObj.speech.say(context.apiObj.i18n.getMessage("copiedLink"))
let href = event.target.value;
context.apiObj.speech.copyString((href.startsWith("mailto:")) ? href.substr(7) : href);

}, // copy link to clipboard 
openURL(url){
if (url.startsWith("mailto:"))
{return this.composeNewMessage(url);}

context.apiObj.windows.openDefaultBrowser(url)
}, // open url 
composeNewMessage(adress){
context.apiObj.compose.beginNew(null, {to: adress.substr(7)})
},// compose new message
OnKeyDown(event){
let SetFocusThreadPane = this.ownerDocument.defaultView.SetFocusThreadPane
let which = event.which;
if (which == event.DOM_VK_SPACE)
{context.apiObj.userMessage.copyLinkToClipboard(event)}
else if (which == event.DOM_VK_RETURN)
{context.apiObj.userMessage.openURL(event.target.value);
SetFocusThreadPane()
}
else if (which == event.DOM_VK_ESCAPE || which == event.DOM_VK_TAB)
{event.preventDefault();
SetFocusThreadPane()}
},// on keydown 
OnBlur(){
this.removeEventListener("keydown", context.apiObj.userMessage.OnKeyDown)
this.removeEventListener("blur", context.apiObj.userMessage.OnBlur);
context.apiObj.userFolder.clearList(this.ownerDocument)
}
      } // userMessage
    } // return object holding experiment APIs
  } // getAPI function
}; // userMessage class
